########## 14.7 ²uʰjkdһP R ާ@ ##########
###### 14.7.1 ²uʰjk˩w ######

SR = lm(formula = ` ~ ˱Ш| , data = Unit_14_mreg_200)
summary(SR)

library(lm.beta)
lm.beta(SR)

########## 14.8 huʰjkdһP R ާ@ ##########
###### 14.8.1 hjkԭzέp ######

library(broom)
des = Unit_14_mreg_200 %>% select(˱Ш| : `)
tidy(des)[ ,c(1:5, 8, 9)]

###### 14.8.3 huʰjkҦ˩w ######

mreg = lm(` ~ ˱Ш| + ˱Ш| + axJ + ɲ + Ƹꥻ , data = Unit_14_mreg_200)
summary(mreg)

library(lm.beta)
lm.beta(mreg)

########## 14.9 jkE_ ##########
###### 14.9.1 uYw ######

library(ggfortify)
autoplot(mreg, which = 1, ncol = 1, label.size = 3)

library(ggplot2)
res = data.frame(cbind(mreg$fitted.values, mreg$residuals))
colnames(res) = c("At", "ݮt")
ggplot(res, aes(x = At , y = ݮt)) +
  geom_point() +
  geom_smooth(method = "lm", color = "purple", se = T) + 
  geom_smooth(se = F) +
  labs(title = "ݮt vs. At") +
  theme(plot.title = element_text(hjust = 0.5))

library(lmtest)
resettest(mreg)

library(tidyverse)
data("Boston", package = "MASS")
bos_lm = lm(medv ~ crim, data = Boston)
library(ggfortify)
autoplot(bos_lm, which = 1, ncol = 1, label.size = 3)
library(lmtest)
resettest(bos_lm)

library(GGally)
boston_dat = Boston %>% select(medv, crim)
ggpairs(boston_dat, lower = list(continuous = wrap("smooth", alpha = 0.3, size=0.1, method = "loess", colour="blue")))

boston_dat$medv_log = log(boston_dat$medv)
bos_lm_log = lm(medv_log ~ crim, data = boston_dat)
autoplot(bos_lm_log, which = 1, ncol = 1, label.size = 3)
resettest(bos_lm_log)

boston_dat$crim_square_root = boston_dat$crim^(1/2)
bos_lm_crim_square_root = lm(medv ~ crim_square_root, data = boston_dat)
autoplot(bos_lm_crim_square_root, which = 1, ncol = 1, label.size = 3)
resettest(bos_lm_crim_square_root)

bos_mreg = lm(medv ~ lstat + age + crim, data = boston_mreg)
autoplot(bos_mreg, which = 1, ncol = 1, label.size = 3)
resettest(bos_mreg)

boston_mreg = Boston %>% select(medv, lstat, age, crim)
ggpairs(boston_mreg, lower = list(continuous = wrap("smooth", alpha = 0.3, size=0.1, method = "loess", colour="blue")))

boston_mreg$medv_reciprocal = -(1/(boston_mreg$medv))
bos_mreg_reciprocal = lm(medv_reciprocal ~ lstat + age + crim, data = boston_mreg)
autoplot(bos_mreg_reciprocal, which = 1, ncol = 1, label.size = 3)
resettest(bos_mreg_reciprocal)

boston_dat$crim_square_root = boston_dat$crim^(1/3)
bos_lm_crim_square_root = lm(medv ~ crim_square_root, data = boston_dat)
autoplot(bos_lm_crim_square_root, which = 1, ncol = 1, label.size = 3)
resettest(bos_lm_crim_square_root)

###### 14.9.2 ݮt`A˩w ######

shapiro.test(mreg$residuals)
library(psych)
skew(mreg$residuals, na.rm = TRUE, type=3)
library(psych)
kurtosi(mreg$residuals, na.rm = TRUE, type=3)

library(tidyverse)
library(psych)
n_norm = lm(y1 ~ x1, data = non_norm1)
shapiro.test(n_norm$residuals)
skew(n_norm$residuals, na.rm = TRUE, type=3)
kurtosi(n_norm$residuals, na.rm = TRUE, type=3)

library(trafo)
transform = boxcox(n_norm, lambda = "estim", method = "ml",
                   lambdarange = c(-4, 4), plotit = TRUE)
transform$lambdahat
da_t = as.data.frame(transform)

n_norm1 = lm(y1t ~ x1, data = da_t)
shapiro.test(n_norm1$residuals)
skew(n_norm$residuals, na.rm = TRUE, type=3)
kurtosi(n_norm$residuals, na.rm = TRUE, type=3)

###### 14.9.3 ݮtܲƦP ######

library(ggfortify)
autoplot(mreg, which =3, ncol = 1)

library(car)
ncvTest(mreg)

library(lmtest)
bptest(mreg)

library(lmtest)
library(sandwich)
coeftest(mreg, vcov = vcovHC(mreg, type="HC1"))

###### 14.9.4 tWߩ˩w ######

library(lmtest)
dwtest(mreg)

library(lawstat)
runs.test(mreg$residuals)

###### 14.9.5 h@u˩w ######

library(car)
vif(mreg)

###### 14.9.6 ȻPvT[ ######

mreg = lm(` ~ ˱Ш| + ˱Ш| + axJ + ɲ + Ƹꥻ , data = ch11_mreg_200)
outlier_indices = ch11_mreg_200
outlier_indices$case_id = row.names(mreg_outlier)
outlier_indices$standardized.residuals <- rstandard(mreg)
outlier_indices$standardized.residuals
outlier_indices$studentized.residuals <- rstudent(mreg)
outlier_indices$cooks.distance <- cooks.distance(mreg)
outlier_indices$leverage <- hatvalues(mreg)
outlier_indices$dfbeta <- dfbeta(mreg)
outlier_indices$dffit<- dffits(mreg)
outlier_indices$covariance.ratios <- covratio(mreg)
outlier_indices$large.residual <- abs(outlier_indices$standardized. residuals) > 3
write.csv(outlier_indices, file = "outlier_indices.csv", row.names = F)

library(tidyverse)
outlier = outlier_indices %>% filter(outlier_indices$large.residual == TRUE)

range(outlier_indices$standardized.residuals)

library(car)
outlierTest(mreg)

outlier_indices_rm = outlier_indices [outlier_indices$case_id != 68, ]
mreg.1 = lm(` ~ ˱Ш| + ˱Ш| + axJ + ɲ + Ƹꥻ , data = outlier_indices_rm)
outlier_indices_3 = outlier_indices[abs(outlier_indices$standardized.residuals) <= 2, ]

library(lindia)
gg_cooksd(mreg, label = TRUE, show.threshold = TRUE,
          threshold = "convention", scale.factor = 0.5)

d = 4/length(outlier_indices$cooks.distance)
outlier_indices %>% filter(outlier_indices$cooks.distance > d) %>%
  select(case_id, cooks.distance)

library(MASS)
robust_lm = rlm(` ~ ˱Ш| + ˱Ш| + axJ + ɲ +
                Ƹꥻ , data = ch11_mreg_200)

########## 14.10 Ҧ ##########
###### 14.10.1 ̦nlk ######

library(olsrr)
library(tidyverse)
mreg = lm(` ~ ˱Ш| + ˱Ш| + axJ + ɲ +
            Ƹꥻ , data = ch11_mreg_200)
best = ols_step_best_subset(mreg)
best = data.frame(best)
best %>% filter(adjr == max(best$adjr))

best_sub = lm(` ~ ˱Ш| + ˱Ш| + axJ + ɲ, data = ch11_mreg_200)
summary(best_sub)

###### 14.10.2 vBjk ######

ols_step_forward_p(mreg, details = T)

ols_step_forward_aic(mreg, details = TRUE)

ols_step_backward_p(mreg, details = TRUE)

ols_step_backward_aic(mreg, details = TRUE)

ols_step_both_p(mreg, details = TRUE)

ols_step_both_aic(mreg, details = TRUE)





